package org.SplitPeaks;

import java.io.BufferedReader;
import java.io.IOException;

public class BedgraphParser extends Parser {

    public BedgraphParser(BufferedReader bufReader) throws IOException {
	
    	super(bufReader,"BED");
    	m_bufRead.mark(1000);
    	String line = m_bufRead.readLine();
            
        String[] myelements = this.split(line);
        if(myelements.length !=4) {
        	throw new IOException ("Invalid BedGraph file format");
        }
      
        //return to be before the first line of signal
        m_bufRead.reset();
    }
		
	public wigPosition nextPosition() throws IOException {
		wigPosition pos = null;
		m_bufRead.mark(1000);
		String line = m_bufRead.readLine();
		if(line==null || line.equals(""))
		{
			return null;
		}
		m_currentOffset += line.length();
		String[] myelements = this.split(line);
		String chr=null;
		int start=0;
		int end=0;
		float score=0;
		try
		{
			 chr = myelements[0];
			 start = Integer.parseInt(myelements[1]);
			 end = Integer.parseInt(myelements[2]);
			 score = Float.parseFloat(myelements[3]);
		}
		catch (Exception e)
		{
			throw new IOException ("Invalid bedGraph file format in line starting with \"" + line + "\"" + "\n");
		}
		pos = new wigPosition(chr,start,end,score);
		return pos;
	}
	public wigPosition nextChrom(String curChr) throws IOException{
		
		wigPosition pos = nextPosition();
		while(pos != null && pos.getChr().equals(curChr))
		{
			pos = nextPosition();
		}
		return pos;
	}
}
