package org.SplitPeaks;

public class Position {

	private int m_Start;
	private int m_End;
	private String m_Chromosome;
	
	
	public Position(int start, int end, String chrom) {
		m_Start = start;
		m_End = end;
		if(chrom.startsWith("chr"))
			m_Chromosome = chrom;
		else if (chrom.startsWith("CHR"))
			m_Chromosome = "chr"+chrom.substring(3);
		else{m_Chromosome = "chr" +chrom;}
	}
	public String getChr() {
		return m_Chromosome;
	}
	public int getStart() {
		return m_Start;
	}
	public int getEnd() {
		return m_End;
	}
	public int contains (Position p) {
		if( (this.m_Start >= p.m_Start && this.m_Start <= p.m_End ) || (this.m_End >= p.m_Start && this.m_End <= p.m_End) ){
			//overlap
			return 0;
		}
		else if (this.m_End < p.m_Start){
			//before
			return -1;
		}
		else {
			//after
			return 1;
			}
	}
}
