package org.SplitPeaks;

import java.util.GregorianCalendar;

import argparser.ArgParser;
import argparser.BooleanHolder;
import argparser.FloatHolder;
import argparser.IntHolder;
import argparser.StringHolder;

public class init 
{
	public static void main(String[] args) throws Exception 
	{	
		//create holder objects for the results
		
		StringHolder peakFile = new StringHolder();
		StringHolder wigFile = new StringHolder();
		FloatHolder bd = new FloatHolder();
		IntHolder cutoff = new IntHolder();
		StringHolder outDir = new StringHolder();
		IntHolder numSeq = new IntHolder();
		BooleanHolder fetch = new BooleanHolder();
		IntHolder length = new IntHolder();
		StringHolder url = new StringHolder();
		StringHolder prefix = new StringHolder();
		
		//add default values to the arguments holders
		numSeq.value = 300;
		bd.value = (float) 0.6;
		cutoff.value=5;
		fetch.value=true;
		length.value=60;
		url.value="http://www.ensembl.org/das/Homo_sapiens.GRCh37.reference";
		prefix.value="";
		
		//create the parser and specify allowed options
		ArgParser parser = new ArgParser("java -jar splitPeaks.jar <options>");
		parser.addOption("-p,--peakFile %s #input peak file", peakFile);
		parser.addOption("-w,--wigFile %s #input wig file or folder", wigFile);
		parser.addOption("-o,--outDir %s #output folder", outDir);
		parser.addOption("-x,--prefix %s # string to add to output file names", prefix);
		parser.addOption("-c,--cutoff %d #height cutoff (default 5)", cutoff);		
		parser.addOption("-v,--valley %f #float value to determine the valley depth required for peak separation (default 0.6)", bd);
		parser.addOption("-f,--fetch %b #whether to fetch subpeaks sequences or not (default true)", fetch);
		parser.addOption("-u,--url %s #Das url (default is for human \"http://www.ensembl.org/das/Homo_sapiens.GRCh37.reference\"", url);
		parser.addOption("-n,--numSeq %d #number of best peak sequences to fetch (default 300)", numSeq);
		parser.addOption("-l,--length %d #length of sequence to fetch (default 60)", length);
			
		//match the arguments, and handle the un-matched
		parser.matchAllArgs(args);
		if(peakFile.value==null || wigFile.value==null || outDir.value==null)
		{
			String help = parser.getHelpMessage();
			System.out.println(help + "\n");
			return;
		}
		else
		{
			try
			{
				Split s = new Split();
				s.init(peakFile.value,wigFile.value,bd.value,cutoff.value,outDir.value,numSeq.value,prefix.value);
				if(fetch.value)
				{
					s.getPeakFasta(url.value, length.value);
				}
				s.clean();	
				System.out.println("program ended successfully");
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
			}
		}
	}

}
